/**
 * Created with AppCode.
 * User: WanThirty
 * Date: 15/9/12
 * Time: 下午4:56
 * To change this template use File | Settings | File Templates.
 */

var AlertMoreCoin = vee.Class.extend({
	_isOver : false,

	onCreate : function () {
		this.playAnimate("show", function () {
			if (game.Data.oLyGame) {
				cc.director.pause();
			}
		}.bind(this));
		this.handleKey(true);
	},

	onKeyBack : function(){
		this.onClose();
		return true;
	},

	btnBuy : null,
	onBuy : function () {
		if (this._isOver) return;
	},

	btnClose : null,
	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;
		if (!game.Data.oPauseCtl) {
			cc.director.resume();
		}
		this.playAnimate("hide", function () {
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	}
});
AlertMoreCoin.show = function () {
	vee.PopMgr.popCCB(res.warnCoin_ccbi, {alpha : 0});
};

var AlertFillEnergy = vee.Class.extend({
	_isOver : false,
	_videoAvailable : false,
	btnBuy : null,
	btnWatch : null,
	btnClose : null,

	onCreate : function () {
		this.handleKey(true);
	},

	ccbInit : function () {
		this._videoAvailable = vee.Ad.checkCacheVideoAd();
		if (game.Data.isWeiXin)
		{
			this.playAnimate("show", this.initController.bind(this));
			this.btnWatch.setBackgroundSpriteForState(new cc.Scale9Sprite(res.btn_power_2_watch_weixin_png), cc.CONTROL_STATE_NORMAL);
		}
		else if (this._videoAvailable)
		{
			this.playAnimate("show", this.initController.bind(this));
		}
		else
		{
			//jin
			this.btnWatch.setEnabled(false);
			this.playAnimate("show_buy_only", this.initController.bind(this));
		}
	},

	initController : function () {
	},

	onKeyBack : function(){
		this.onClose();
		return true;
	},

	onBuy : function () {
		vee.IAPMgr.buyProduct(2, function () {
			vee.PopMgr.closeLayerByCtl(this);
			game.Data.fillEnergy();
			game.Data.energyUnlimited(game.Data.energyUnlimitedTime);
			if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.showEnergy();
			vee.Utils.scheduleOnce(function () {
				vee.PopMgr.alert(
					vee.Utils.getLocalizedStringForKey("You`ve got MAX energy for 20 min!"),
					vee.Utils.getLocalizedStringForKey("CONGRATULATION")
				);
			}, 0.2);
		});
	},

	onWatch : function () {
		vee.Ad.showVideoAd(function (pPlugin, num, itemID) {
			vee.PopMgr.closeLayerByCtl(this);
			game.Data.addEnergy(1);
			if (game.Data.oEnergyCtl) game.Data.oEnergyCtl.showEnergy();
			vee.Utils.scheduleOnce(function () {
				vee.PopMgr.alert(
					vee.Utils.getLocalizedStringForKey("You`ve got an energy!"),
					vee.Utils.getLocalizedStringForKey("CONGRATULATION")
				);
			}, 0.2);
		}.bind(this));
	},

	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;
		var endFunc = function () {
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this);
		if (this._videoAvailable) {
			this.playAnimate("hide", endFunc);
		} else {
			this.playAnimate("hide_buy_only", endFunc);
		}
	}
});
AlertFillEnergy.show = function () {
	var node = vee.PopMgr.popCCB(res.warnLife_ccbi, {alpha : 0});
	node.controller.ccbInit();
};

var AlertUnlockCategory = vee.Class.extend({
	_isOver : false,
	_tempControllerState : null,
	_anim : null,
	_idx : 0,

	lbCase1 : null,
	lbCase2 : null,
	lbCase3 : null,
	lbCase4 : null,

	lbTitle : null,
	lbLevel : null,
	spStar : null,

	labPrice : null,

	isStarUnlockEnable : false,

	onCreate : function () {
		this.handleKey(true);
		this._tempControllerState = vee.Controller.cacheControllerState();
	},

	ccbInit : function (idx) {
		this._anim = "";
		//cc.log("idx ====" + idx);
		this._idx = idx;
		this.lbLevel.setString(this._idx + "-" + game.LevelData.getCategory(this._idx - 1).levelCount);

		this.lbCase4.setString("");

		if (game.Data.isSelectingReverseWorld) {
			if(game.Data.version.newVersion){
				this.lbLevel.setString(this._idx + "-1");
			}
			this._anim = "_moon";
			this.playAnimate("show" + this._anim);
			return;
		}

		if (this._idx > 7 && this._idx < 100) {
			this._anim = "";
			this.playAnimate("show" + this._anim);
			return;
		}

		var data = game.LevelData.getCategory(idx - 1);
		var starNeed = parseInt(data.unlockStar);
		var starNow = parseInt(game.LevelData.getStar());
		if (starNeed < starNow) {
			this.isStarUnlockEnable = true;
		}

		if (this.isStarUnlockEnable) {
			this._anim = "_free";
		}
		else {
			if (idx == 2) {
				this._anim = "_ok";
				this.lbCase3.setString("");
			}
			else {
				this._anim = "_buy";
				this.lbStarDesc.setColor(cc.color(100, 0, 0));
			}
		}

		this.playAnimate("show" + this._anim);
		if (!vee.Ad.checkCacheVideoAd()) {
			this.btnVideo.setEnabled(false);
		}
	},

	initController : function () {
		vee.Controller.initSelector(1,1,this.onClose.bind(this),cc.p(0,0));
		if (game.Data.isFreeGame && (this._idx > 7 && this._idx < 100) ) {
			if (this._anim == "_video") {
				vee.Controller.registerItemByButton(this.btnVideo, cc.p(0,0), this.onVideo.bind(this), "res/mfi_btn_on_170.png");
			} else if (this._anim == "_free") {
				vee.Controller.registerItemByButton(this.btnFree, cc.p(0,0), this.onFree.bind(this), "res/mfi_btn_on_170.png");
			} else if (this._anim == "_buy") {
				vee.Controller.registerItemByButton(this.btnBuy, cc.p(0,0), this.onBuy.bind(this), "res/mfi_btn_on_170.png");
			} else {
				vee.Controller.registerItemByButton(this.btnOk, cc.p(0,0), this.onConfirm.bind(this), "res/mfi_btn_on_170.png");
			}
		} else {
			vee.Controller.registerItemByButton(this.btnOk, cc.p(0,0), this.onConfirm.bind(this), "res/mfi_btn_on_170.png");
		}
		vee.Controller.activeSelector();
	},

	onKeyBack : function(){
		this.onClose();
		return true;
	},

	lbStarDesc : null,
	lbCase1Moon : null,

	setStarDesc : function (str) {
		if (this._idx > 7 && this._idx < 100) {   // 中秋关卡

			this.lbTitle.setString(vee.Utils.getLocalizedStringForKey("LOCKED"));
			this.lbStarDesc.setString(this.getLevelTimeStr(parseInt(game.Data.getLevel61LeftTime())));
			var newX = this.lbStarDesc.getPosition().x + 60;
			this.lbStarDesc.setPosition(cc.p(newX, this.lbStarDesc.getPosition().y));
			this.spStar.setVisible(false);
			this.lbCase1.setString(vee.Utils.getLocalizedStringForKey("Need to wait"));
			this.lbCase2.setString(vee.Utils.getLocalizedStringForKey("to unlock this world"));
			this.lbCase3.setVisible(false);
			return;
		}
		this.lbStarDesc.setString(str);

		if (game.Data.isSelectingReverseWorld) {
			var str = this.lbCase1.getString();
			cc.log("idx = " + this._idx);
			var category = game.LevelData.getCategory(this._idx - 1);
			var categoryTitle = "";
			if (category) {
				categoryTitle = category.title;
				cc.log("category title = "+categoryTitle);
			}
			this.lbCase1.setString(
				vee.Utils.getLocalizedStringForKey(str) + " " +
				vee.Utils.getLocalizedStringForKey(categoryTitle)
			);
			this.lbCase1Moon.setString(
				vee.Utils.getLocalizedStringForKey("You need to complete previous levels") + " " +
				vee.Utils.getLocalizedStringForKey(categoryTitle)
			);
		}

		if (!this.isStarUnlockEnable) {
			var itemIdx = this._idx + 7;
			this.labPrice.setString(game.ItemData.ItemDetail[itemIdx].priceDesc);
		}
	},

	getLevelTimeStr : function(leftTime) {
		var h = Math.floor((leftTime) / (60 * 60));
		var m = Math.floor((leftTime / 60 - h * 60));
		var strM = m < 10 ? "0"+m : m;
		var strH = h < 10 ? "0"+h : h;
		return (strH + ":" + strM);
	},

	btnOk : null,
	onConfirm : function() {
		this.onClose();
	},

	btnFree : null,
	onFree : function() {
		this.onClose();
		if (game.Data.oLvSelectCtl) {
			game.Data.oLvSelectCtl.unlockCategoryByIdx(this._idx, true);
		}
	},

	btnVideo : null,
	onVideo : function() {
		var successCallback = function (pPlugin, num, itemID) {
			this.onClose();
			if (game.Data.oLvSelectCtl) {
				game.Data.oLvSelectCtl.unlockCategoryByIdx(this._idx, true);
			}
		}.bind(this);
		vee.Ad.showVideoAd(successCallback);
	},

	btnBuy : null,
	onBuy : function () {
		if (this.isStarUnlockEnable) {
			this.onClose();
			if (game.Data.oLvSelectCtl) {
				game.Data.oLvSelectCtl.unlockCategoryByIdx(this._idx);
			}
		}
		else {
			var itemIdx = this._idx + 7;  // chapter 3 start from 10
			vee.IAPMgr.buyProduct(itemIdx, function () {
				this.onClose();
				game.ItemData.BuyItemDone(itemIdx);
				//vee.Analytics.logChargeSuccess(game.Data.orderId);
			}.bind(this), function () {
				vee.alert(
					vee.Utils.getLocalizedStringForKey("Purchase Failed"),
					vee.Utils.getLocalizedStringForKey("There is something wrong in purchase")
				);
			}.bind(this));
		}
	},

	btnClose : null,
	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;
		vee.Audio.playEffect(res.outGame_menu_leaveLocked_mp3);
		var hideAnim = game.Data.isFreeGame ? ("hide" + this._anim) : "hide";
		if (this._idx == 7 || this._idx == 8) {
			hideAnim = "hide_time";
		}
		if (game.Data.isSelectingReverseWorld) {
			hideAnim = "hide_moon";
		}
		this.playAnimate(hideAnim, function () {
			vee.Controller.reviveControllerState(this._tempControllerState);
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
		vee.Controller.deactiveSelector();
	}
});

AlertUnlockCategory.show = function (starDesc, idx) {
	var ccbName;
	if (game.Data.isFreeGame) {
		ccbName = res.warnLock_free_ccbi;
		//cc.log("index=======%d", idx);
		if (idx == 6 || idx == 7 || game.Data.isSelectingReverseWorld) {
			ccbName = res.warnLock_ccbi;
		}
	} else {
		ccbName = res.warnLock_ccbi;
	}
	var node = vee.PopMgr.popCCB(ccbName, {alpha : 0});
	node.controller.ccbInit(idx + 1);

	if (!game.Data.isSelectingReverseWorld) {
		var data = game.LevelData.getCategory(idx);
		var starNeed = data.unlockStar;
		var starNow = game.LevelData.getStar();
		var str = "" + starNow + "/" + starNeed;
		node.controller.setStarDesc(str);
	}
	else {
		node.controller.setStarDesc(starDesc);
	}
};

//jin
var AlertUsePower = vee.Class.extend({

	ccbUIEnergy : null,
	emptyType : 0,

	onCreate : function () {
		this.playAnimate("show");
		this.ccbUIEnergy.setVisible(false);
		this.handleKey(true);
		vee.Controller.cacheControllerState(this);
	},

	onKeyBack : function(){
		this.onClose();
		return true;
	},

	initController : function () {
		vee.Controller.initSelector(1,1,this.onClose.bind(this), cc.p(0,0));
		vee.Controller.registerItemByButton(this.btnUse, cc.p(0,0), this.onUse.bind(this), "res/mfi_btn_on_170.png");
		vee.Controller.activeSelector();
	},

	setEmptyType : function(emptyType) {
		this.emptyType = emptyType;
	},

	btnUse : null,
	onUse : function () {
		this.onClose();
		game.Data.fillEnergy();
		game.Data.energyUnlimited(game.Data.energyUnlimitedTime);
		vee.dataManager.setPower(vee.dataManager.getPower() - 1);
		vee.dataManager.setPowerTs(vee.Utils.getTimeNow());
		switch (this.emptyType) {
			case game.LifeEmptyType.Select :
				if (game.Data.oEnergyCtl) {
					game.Data.oEnergyCtl.usePower();
				}
				break;
			case game.LifeEmptyType.Lose :
				if (game.Data.oLyGameOver) {
					this.playAnimate("showPower", function () {
						game.Data.oLyGameOver.loseRetry();
					});
					this.showUsePower();
				}
				break;
			//case game.LifeEmptyType.WinRetry :
			//	if (game.Data.oLyGameOver) {
			//		this.playAnimate("showPower", function () {
			//			game.Data.oLyGameOver.winRetry();
			//		});
			//		this.showUsePower();
			//	}
			//	break;
			//case game.LifeEmptyType.WinNext :
			//	if (game.Data.oLyGameOver) {
			//		this.playAnimate("showPower", function () {
			//			game.Data.oLyGameOver.winNext();
			//		});
			//		this.showUsePower();
			//	}
			//	break;
			default :
				break;
		}
	},

	showUsePower : function() {
		vee.Utils.scheduleOnce(function() {
			this.ccbUIEnergy.setVisible(true);
			this.ccbUIEnergy.controller.playAnimate("usePower");
		}.bind(this), 1.0);
	},

	btnClose : null,
	_isOver : false,
	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;
		vee.Controller.deactiveSelector();
		this.playAnimate("hide", function () {
			vee.Controller.reviveControllerStateByCtl(this);
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	}
});
AlertUsePower.show = function (emptyType) {
	var lyUsePower = vee.PopMgr.popCCB(res.warnUsePower_ccbi, {alpha : 0});
	lyUsePower.controller.setEmptyType(emptyType);
};

var AlertGetPower = vee.Class.extend({
	lbWatch : null,
	emptyType : 0,

	ccbCell1 : null,
	ccbCell2 : null,
	ccbCell3 : null,
	ccbCell4 : null,
	ccbCell5 : null,

	onCreate : function () {
		AlertGetPower.instance = this;
		this.playAnimate("show");
		this.handleKey(true);
		vee.Controller.cacheControllerState(this);
	},

	onKeyBack : function(){
		this.onClose();
		return true;
	},

	initController : function () {
		vee.Controller.initSelector(2,1,this.onClose.bind(this),cc.p(0,0));
		//vee.Controller.registerItemByButton(this.btnBuy, cc.p(0,0), this.onBuy.bind(this), "res/mfi_btn_on_170.png");
		//vee.Controller.registerItemByButton(this.btnWatch, cc.p(1,0), this.onWatch.bind(this), "res/mfi_btn_on_170.png");
		vee.Controller.activeSelector();
	},

	setEmptyType : function(emptyType) {
		this.emptyType = emptyType;
	},

	btnClose : null,
	_isOver : false,
	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;
		vee.Controller.deactiveSelector();
		vee.Controller.reviveControllerStateByCtl(this);

		this.playAnimate("hide", function () {
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	}
});

AlertGetPower.instance = null;

AlertGetPower.show = function (emptyType) {
	var lyGetPower = vee.PopMgr.popCCB(res.warnGetPower_ccbi, {alpha : 0});
	lyGetPower.controller.setEmptyType(emptyType);
};

AlertGetPower.hide = function () {
	if (!AlertGetPower.instance)
		return;
	AlertGetPower.instance.onClose();
}

VeeQuitBox.show = function(closecallback) {
	if (VeeQuitBox.hasShow) return;
	if (vee.Promo.isActivated && vee.data.adEnabled) {
		vee.PopMgr.popCCB("vQuit.ccbi", true);
	} else {
		var ctl = vee.PopMgr.alert(
			vee.Utils.getLocalizedStringForKey("Do you want to leave the game? (Your game progress will not be saved.)"),
			vee.Utils.getLocalizedStringForKey("QUIT"),
			function(){
				// Confirm callback
				app.closeGame();
				vee.Director.end();
				app.closeGame();
			},
			function(){
				// Close callback
				if (closecallback) closecallback();
			});
	}
};

var AlertMoonLocked = vee.Class.extend({
	btnBuy : null,
	btnClose : null,
	_isOver : false,
	_levelIdx : null,
	_tempControllerState : null,

	isSpacial : false,

	ccbInit : function (idx, isSpacial) {
		this.handleKey(true);
		this._tempControllerState = vee.Controller.cacheControllerState();
		this._levelIdx = idx;
		this.playAnimate("show");

		this.isSpacial = false;
		if(isSpacial && !this.checkIsPass()){
			this.isSpacial = true;
			var moonCategory = game.LevelData.selectedCategory;
			var catgory = game.LevelData.getCategory(moonCategory.idx - 100);
			this.lbCase2.setString(vee.Utils.getLocalizedStringForKey("Play the corresponding") + " " + vee.Utils.getLocalizedStringForKey(catgory.title) + " " + (catgory.idx+1) + "-" + (idx+1) + "\n" + vee.Utils.getLocalizedStringForKey("find the Moon Key to UNLOCK!"));
//			this.lbCase2.setString("alerts.js 552 line test===" + catgory.title);
		}
	},

	initController : function () {
		vee.Controller.initSelector(1,1,this.onClose.bind(this),cc.p(0,0));
		vee.Controller.registerItemByButton(this.btnBuy, cc.p(0,0), this.onBuy.bind(this), "res/mfi_btn_on_170.png");
		vee.Controller.activeSelector();
	},

	checkIsPass : function(){
		cc.log("check is pass");
		var moonCategory = game.LevelData.selectedCategory;
		var reverseCategoryIdx = moonCategory.idx - 100;
		var category = game.LevelData.getCategory(reverseCategoryIdx);
		return category.getLevelDataController(this._levelIdx).levelData.isLevelPassed;

//		cc.log("check is pass moonLevel===%d", moonLevel.);
//		return category.isLevelPassed;
	},

	onKeyBack : function () {
		this.onClose();
		return true;
	},

	onBuy : function () {

		cc.log("unlock moon level-------------");
		if(this.isSpacial){
			this.onClose();
			return;
		}

		var category = game.LevelData.selectedCategory;
		var reverseCategoryIdx = category.idx - 100;
		game.LevelData.selectedCategory = game.LevelData.getCategory(reverseCategoryIdx);
		game.LevelData.selectedLevel = game.LevelData.selectedCategory.getLevelDataController(this._levelIdx);
		game.Logic.startGame(game.LevelData.levelMap[game.LevelData.selectedLevel.getLevelNo()-1]);
		vee.Controller.deactiveButton();
		vee.Controller.deactiveSelector();
	},

	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;

		this.playAnimate("hide", function () {
			vee.Controller.reviveControllerState(this._tempControllerState);
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
		vee.Controller.deactiveSelector();
	}
});

//isSpecial=android免费版逻辑特别处理，关卡未解锁弹窗直接关闭
AlertMoonLocked.show = function (idx, isSpecial) {
	var node = vee.PopMgr.popCCB(res.warnMoon_Lock_ccbi, true);
	node.controller.ccbInit(idx, isSpecial);
};

var AlertFacebook = vee.Class.extend({

	ccbInit : function(){
		this.handleKey(true);

		this.playAnimate("show");
	},

	onClick : function(){
		this.onClose();
		game.AvatarData.unlockMidAutRole();
		game.AvatarData.avatarSelected(12);
		LyUnlock.show(12);
	},

	onClose : function(){
		if(this._isOver) return;
		this._isOver = true;

		this.playAnimate("hide", function(){
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));

	},

	onKeyBack : function(){
		this.onClose();
	}
});

AlertFacebook.show = function(){
	var node = vee.PopMgr.popCCB(res.lyNewAvatar_ccbi, true);
	node.controller.ccbInit();
};


/*
 var AlertGetHolloweenRoleVideo = vee.Class.extend({

 btnFaceBook : null,

 ccbInit : function(){
 this.handleKey(true);

 this.playAnimate("show");

 if(!vee.Ad.checkCacheVideoAd()){
 this.btnFaceBook.setEnabled(false);
 }
 },

 onClick : function(){

 // if(true){
 // 	vee.Ad.showInterstitialAd();
 // 	return;
 // }

 if(vee.Ad.checkCacheVideoAd()){
 this.onClose();
 game.AvatarData.unlockHolloweenRole();
 }
 else{
 cc.log("js = ad video is not ready");
 }

 },

 onClose : function(){
 if(this._isOver) return;
 this._isOver = true;

 this.playAnimate("hide", function(){
 vee.PopMgr.closeLayerByCtl(this);
 }.bind(this));
 },

 onKeyBack : function(){
 this.onClose();
 }
 });


 AlertGetHolloweenRoleVideo.show = function () {
 var node = vee.PopMgr.popCCB(res.lyNewAvatarHolloween_ccbi, true);
 node.controller.ccbInit();
 };
 */


var AlertUnlockRoleByVideo = vee.Class.extend({

	ccbAvatar : null,

	avatarId : null,

	ccbInit : function(avatarId){
		this.handleKey(true);
		var avatarData = game.AvatarData.getAvatarData(avatarId);
		this.avatarId = avatarId;
		this.ccbAvatar.setTexture(avatarData.picName);

		this.playAnimate("show");

		if(!vee.Ad.checkCacheVideoAd()){
			this.btnFaceBook.setEnabled(false);
		}
	},

	onClick : function(){

		// if(true){
		// 	vee.Ad.showInterstitialAd();
		// 	return;
		// }

		if(vee.Ad.checkCacheVideoAd()){
			this.onClose();
			game.AvatarData.unlockVideoRoleByAvatarId(this.avatarId);
		}
		else{
			cc.log("js = ad video is not ready");
		}
	},

	onClose : function(){
		if(this._isOver) return;
		this._isOver = true;

		this.playAnimate("hide", function(){
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	},

	onKeyBack : function(){
		this.onClose();
	}
});

/**
 *
 * @param avatarId
 */
AlertUnlockRoleByVideo.show = function (avatarId) {
	var node = vee.PopMgr.popCCB(res.lyUnlockVideoRole_ccbi, true);
	node.controller.ccbInit(avatarId);
};


var AlertParkourTip = vee.Class.extend({

	alertCallback : null,

	parentNode : null,

	ccbInit : function(callback){
		this.handleKey(true);
		// var avatarData = game.AvatarData.getAvatarData(avatarId);
		// this.avatarId = avatarId;
		// this.ccbAvatar.setTexture(avatarData.picName);

		this.alertCallback = callback;

		this.playAnimate("show_moon");

		// vee.GestureController.registerController(this, this, true);
		// if(!vee.Ad.checkCacheVideoAd()){
		// 	this.btnFaceBook.setEnabled(false);
		// }
		var listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: this.onGestureBegin
		});

		// this._eventListenser = listener;
		cc.eventManager.addListener(listener, this.parentNode);

		vee.Controller.cacheControllerState(this);

		vee.Controller.clearAllButtonAction();

		vee.Controller.registerButtonAction(
			[vee.KeyCode.BUTTON_B, vee.KeyCode.BUTTON_A],
			this.onClose.bind(this)
		);
		vee.Controller.activeButton();
	},

	onGestureBegin : function (touch, event) {
		var layer = event.getCurrentTarget();
		// layer.onClick();
		cc.log("zq debug ==============onGestureBegin");
		layer.controller.onClick();
		return true;
	},

	onClick : function(){
		this.onClose();
	},

	onClose : function(){
		if(this._isOver) return;
		this._isOver = true;

		vee.Controller.reviveControllerStateByCtl(this);

		this.alertCallback();

		this.playAnimate("hide_moon", function(){
			vee.PopMgr.closeLayerByCtl(this);
		}.bind(this));
	},

	onKeyBack : function(){
		this.onClose();
	},

	setNode : function (node) {
		this.parentNode = node;
	}
});

AlertParkourTip.show = function (callback) {
	var node = vee.PopMgr.popCCB(res.warnParkourTip_ccbi, false);
	node.controller.setNode(node);
	node.controller.ccbInit(callback);
};