/**
 * Created with AppCode.
 * User: WanThirty
 * Date: 16/1/15
 * Time: 下午4:03
 * To change this template use File | Settings | File Templates.
 */

var LyGetBlackCat = vee.Class.extend({
	btnVideo : null,
	btnOK : null,

	_isOver : false,
	_tempControllerState : null,

	ccbInit : function () {
		game.Data.oLyGame.leftBtnUp();
		game.Data.oLyGame.rightBtnUp();
		vee.Audio.playEffect(res.inGame_function_unlockAvator_mp3);
		if (game.Data.isFreeGame) {
			this.playAnimate("open_pro");
			//this.playAnimate("open");
		} else {
			this.playAnimate("open_pro");
		}

		this._tempControllerState = vee.Controller.cacheControllerState();
	},

	initController : function () {
		vee.Controller.initSelector(1,1,this.onClose.bind(this),cc.p(0,0));
		var btnCallback = null;
		var btn = null;
		if (game.Data.isFreeGame) {
			btnCallback = this.onOK.bind(this);
			btn = this.btnOK;
			//btnCallback = this.onVideo.bind(this);
			//btn = this.btnVideo;
		} else {
			btnCallback = this.onOK.bind(this);
			btn = this.btnOK;
		}
		vee.Controller.registerItemByButton(btn, cc.p(0,0), btnCallback, "res/mfi_btn_on_210.png");
		vee.Controller.activeSelector();
	},

	onVideo : function() {
		if (this._isOver) return;
		if (game.LevelData.selectedCategory && game.LevelData.selectedLevel) {
			var category = game.LevelData.selectedCategory.idx + 1;
			var level = game.LevelData.selectedLevel.idx + 1;
			// key analy
			vee.Analytics.logEvent("GetBlackCatAt"  + category + "0" + level);
		}
		var successCall = function (pPlugin, num, itemID) {
			game.Data.oLyGame.resumeGame();
			vee.PopMgr.closeLayer();
			vee.Utils.scheduleOnce(function() {
				ItemTransformBox.transformToHawk();
			}, 2.0);
		}.bind(this);

		vee.Ad.showVideoAd(successCall);
	},

	onOK : function () {
		if (this._isOver) return;
		if (game.LevelData.selectedCategory && game.LevelData.selectedLevel) {
			var category = game.LevelData.selectedCategory.idx + 1;
			var level = game.LevelData.selectedLevel.idx + 1;
			// key analy
			vee.Analytics.logEvent("GetBlackCatAt"  + category + "0" + level);
		}
		game.Data.oLyGame.resumeGame();
		ItemTransformBox.transformToHawk();
		this.onClose();
	},

	onClose : function () {
		if (this._isOver) return;
		this._isOver = true;

		vee.Controller.deactiveSelector();
		vee.Controller.reviveControllerState(this._tempControllerState);

		if (game.Data.isFreeGame) {
			this.playAnimate("hide_pro", this.closeFunc.bind(this));
			//this.playAnimate("hide", this.closeFunc.bind(this));
		} else {
			this.playAnimate("hide_pro", this.closeFunc.bind(this));
		}
	},

	closeFunc : function () {
		vee.PopMgr.closeLayerByCtl(this);
		game.Data.oLyGame.resumeGame();
	}
});

LyGetBlackCat.show = function () {
	if (game.Data.isFreeGame) {
		//if (vee.Ad.checkCacheVideoAd()) {
			var node = vee.PopMgr.popCCB(res.lyBlackCatPower_ccbi, { alpha : 0 });
			node.controller.ccbInit();
			game.Data.oLyGame.pauseGame();
		//}
	} else {
		var node = vee.PopMgr.popCCB(res.lyBlackCatPower_ccbi, { alpha : 0 });
		node.controller.ccbInit();
		game.Data.oLyGame.pauseGame();
	}
};