
if (vee.GameModule) {
	vee.GameModule.MainLayer.extend({
		ccbSelectLayer : null,

		onLoaded : function() {
			this.ccbSelectLayer.controller.onLoaded();
		},
		onKeyBack : function(){
			if (!LyAvatarStore.isShow) {
				vee.onKeyBack();
			}
		},

		onSetting : function () {
			LyPosSetting.show();
		}
	});

	vee.GameModule.OverLayer.extend({
		getShareContent : function() {
			return "这才是真正的 分享字符串";
		}
	});
	vee.GameModule.SceneMgr.openOver = function(){
		cc.log("game.Data.stageType = "+game.Data.stageType);
		if (game.Data.stageType == game.StageType.Mini) {
			LyGameOverMini.show();
		} else {
			vee.PopMgr.closeAll();
			var ctlOver = vee.PopMgr.popCCB(this.overFile, true).controller;
			if (game.Data.oLyGameOver) game.Data.oLyGameOver.onLoaded();
		}
	};
}


game.initPhantomCatData = function () {
	var data = vee.Utils.loadObj("VeeData");
	if (!data) {
		vee.isFirstPlay = true;
		vee.data["veewocheck"] = "ok";
		vee.saveData();
	} else {
		vee.isFirstPlay = false;
		vee.data = data;
	}
	app.init(vee.isFirstPlay);
	game.Data.init();
	game.LevelData.categories = [];
	game.LevelData.load();
	game.AvatarData.init();
	vee.saveData();
	vee.VIPValues.save();
};
game.loginPlatform = "";


function main(){
	vee.init();
	game.Data.init();
	vee.Controller.active();
	//vee.PopMgr.autoGarbageCollect(1);

	game.LevelData.load();
	game.AvatarData.init();
	app.checkData();

	if (game.Data.isFreeGame) {
		app.Config.AnalysticsPluginConfig = vee.Utils.getObjByPlatform("56691d48e0f55ab3de000010", "55ffa3bde0f55ae39f003687", "");
	} else {
		app.Config.AnalysticsPluginConfig = vee.Utils.getObjByPlatform("55ffa36167e58eb467002958", "56691d0767e58ebf2d001d32", "");
	}
	vee.Analytics.activate();

	vee.IAPMgr.activate();
	
	vee.Utils.checkPackage();

	//vee.Ad.activate();

	var startFunc = function () {
		// for demo
//		vee.isFirstPlay = false;
		vee.PopMgr.closeAll();
		if (vee.dataManager.getPower() == undefined) {
			vee.dataManager.setPower(1);
		}
		vee.saveData();

		game.CISData.initCISData();

		if (vee.isFirstPlay) {
			var gameStartFunc = function () {
				vee.PopMgr.closeAll();
				cc.director.purgeCachedData();
				vee.PopMgr.popCCB("res/veeGameLayer.ccbi");
				game.Data.oLyGame.onLoaded();
				vee.Analytics.logEvent("story_start");
				game.Data.oLyGame.initStage('Story1');
				game.Data.oLyGame.setFirstPlay(true);
			};
			if (game.Data.isAndroid) {
				var para = {
					"Type" : "Android.Mi",
				};
				vee.Analytics.logEvent("Register", para);
				vee.Transition.out(res.MapTransition_ccbi, gameStartFunc);
			}
			else {
				vee.Transition.out(res.MapTransition_ccbi, gameStartFunc);
			}
		}
		else {   // not first play
			LyIndex.show();

			var para = {
				"Level" : game.LevelData.getStar(),
			};
			vee.Analytics.logEvent("Login", para);
		}

		if (game.Data.isFreeGame && game.Data.isAndroid) {
			vee.Utils.scheduleOnce(function () {
				cc.log("show open screen ad!");
				vee.Ad.showInterstitialByOnlineConfig("open_screen");
			}, 1.4);
		}
	};

	if (game.Data.isAndroid) {
		LySplash.show();
		vee.Utils.scheduleOnce(function () {
			vee.PopMgr.closeAll();
			startFunc();
		}, 2);
		//LyWeiXinOpen.show();
		//vee.Utils.scheduleOnce(function ()
		//}, 2);
	}
	else {
		startFunc();

		vee.Utils.scheduleOnce(function () {
			cc.log("show open screen ad!");
			vee.Ad.showInterstitialByOnlineConfig("open_screen");
		}, 2);
	}

	// keyboard listener for web
	if (vee.Utils.getObjByPlatform(false,false,true)) {
		gameCanvas.addEventListener('keydown', doKeyDown, true);
		gameCanvas.addEventListener('keyup', doKeyUp, true);
		gameCanvas.focus();

		function doKeyDown(e) {
			if (!game.Data.oLyGame) return;
			var keyID = e.keyCode ? e.keyCode :e.which;
			if(keyID === 38 || keyID === 87)  { // up arrow and W
				game.Data.oLyGame.onJump(null, cc.CONTROL_EVENT_TOUCH_DOWN);
			}
			if(keyID === 39 || keyID === 68)  { // right arrow and D
				game.Data.oLyGame.onRight(null, cc.CONTROL_EVENT_TOUCH_DOWN);
			}
			if(keyID === 40 || keyID === 83)  { // down arrow and S
			}
			if(keyID === 37 || keyID === 65)  { // left arrow and A
				game.Data.oLyGame.onLeft(null, cc.CONTROL_EVENT_TOUCH_DOWN);
			}
			if (keyID == 32) { // space bar
				game.Data.oPlayerCtl.BButton();
				game.Data.oPlayerCtl.BButton(true);
			}
		}

		function doKeyUp(e) {
			if (!game.Data.oLyGame) return;
			var keyID = e.keyCode ? e.keyCode :e.which;
			if(keyID === 38 || keyID === 87)  { // up arrow and W
			}
			if(keyID === 39 || keyID === 68)  { // right arrow and D
				game.Data.oLyGame.onRight(null, 32);
			}
			if(keyID === 40 || keyID === 83)  { // down arrow and S

			}
			if(keyID === 37 || keyID === 65)  { // left arrow and A
				game.Data.oLyGame.onLeft(null, 32);
			}
		}
	}

	if (vee.data["tag_61"] == undefined) {
		vee.data["tag_61"] = 1;
		var state_61 = game.LevelData.getCategory(6).getLevelDataController(0).getLevelState();
		if (state_61 != 2) {
			vee.data["level61_ts"] = vee.Utils.getTimeNow();
		}
	}
}

VeeRestorePurchaseButton.registerCallback(function(productid) {

});

vee.Transition.pop = function(ccb, pos){
	var node = cc.BuilderReader.load(ccb, null, null, true);
	var lyTouch = cc.LayerGradient.create(cc.color(0,0,0,150),cc.color(0,0,0,150));
	lyTouch.setOpacity(0);
	cc.eventManager.addListener({
		event: cc.EventListener.TOUCH_ONE_BY_ONE,
		swallowTouches: true,
		onTouchBegan: function(touches, event){
			return true;
		}
	}, lyTouch);
	node.addChild(lyTouch);
	vee.PopMgr.rootNode.addChild(node);
	if (pos) node.setPosition(pos);
	else vee.PopMgr.setNodePos(node, vee.PopMgr.PositionType.Center, cc.p(0,0), true);
	return node;
};